diff --exclude=CVS --exclude=.cvsignore -Nur olsrd-0.5.0/lib/httpinfo/src/olsrd_httpinfo.c olsrd-current/lib/httpinfo/src/olsrd_httpinfo.c
--- olsrd-0.5.0/lib/httpinfo/src/olsrd_httpinfo.c	2007-02-04 23:37:36.000000000 +0100
+++ olsrd-current/lib/httpinfo/src/olsrd_httpinfo.c	2007-05-17 13:25:27.000000000 +0200
@@ -981,48 +1029,45 @@
   struct link_entry *link = NULL;
   int size = 0, index, thop_cnt;
 
-  size += sprintf(&buf[size], "<h2>Links</h2>\n");
-  size += sprintf(&buf[size], "<table width=\"100%%\" BORDER=0 CELLSPACING=0 CELLPADDING=0 ALIGN=center><tr><th>Local IP</th><th>remote IP</th><th>Hysteresis</th>\n");
+  size += snprintf(&buf[size], bufsize-size, "<h2>Links</h2>\n");
+  size += snprintf(&buf[size], bufsize-size, "<table width=\"100%%\" BORDER=0 CELLSPACING=0 CELLPADDING=0 ALIGN=center><tr><th>Local IP</th><th>Remote IP</th><th>Hysteresis</th>\n");
   if (olsr_cnf->lq_level > 0)
-    size += sprintf(&buf[size], "<th>LinkQuality</th><th>lost</th><th>total</th><th>NLQ</th><th>ETX</th>\n");
-  size += sprintf(&buf[size], "</tr>\n");
+    size += snprintf(&buf[size], bufsize-size, "<th>LinkQuality</th><th>lost</th><th>total</th><th>NLQ</th><th>ETX</th>\n");
+  size += snprintf(&buf[size], bufsize-size, "</tr>\n");
 
   /* Link set */
   link = link_set;
     while(link)
       {
-	size += sprintf(&buf[size],
-                       "<tr><td>%s</td>"
-                       "<td><a href=\"http://%s:%d/all\">%s</a></td>"
-                       "<td>%0.2f</td>",
-                       olsr_ip_to_string(&link->local_iface_addr),
-                       olsr_ip_to_string(&link->neighbor_iface_addr),
-                       http_port,
-                       olsr_ip_to_string(&link->neighbor_iface_addr),
+        size += snprintf(&buf[size], bufsize-size, "<tr>");
+        size += build_ipaddr_no_link(&buf[size], bufsize, &link->local_iface_addr, NULL);
+        size += build_ipaddr_with_link(&buf[size], bufsize, &link->neighbor_iface_addr, NULL);
+	size += snprintf(&buf[size], bufsize-size,
+                       "<td align=\"right\">%0.2f</td>",
                        link->L_link_quality);
         if (olsr_cnf->lq_level > 0)
           {
-	    size += sprintf(&buf[size],
-                           "<td>%0.2f</td>"
+	    size += snprintf(&buf[size], bufsize-size,
+                           "<td align=\"right\">%0.2f</td>"
                            "<td>%d</td>"
                            "<td>%d</td>"
-                           "<td>%0.2f</td>"
-                           "<td>%0.2f</td></tr>\n",
+                           "<td align=\"right\">%0.2f</td>"
+                           "<td align=\"right\">%0.2f</td></tr>\n",
                            link->loss_link_quality,
                            link->lost_packets, 
                            link->total_packets,
                            link->neigh_link_quality, 
                            (link->loss_link_quality * link->neigh_link_quality) ? 1.0 / (link->loss_link_quality * link->neigh_link_quality) : 0.0);
           }
-	size += sprintf(&buf[size], "</tr>\n");
+	size += snprintf(&buf[size], bufsize-size, "</tr>\n");
 
 	link = link->next;
       }
 
-  size += sprintf(&buf[size], "</table>\n");
+  size += snprintf(&buf[size], bufsize-size, "</table>\n");
 
-  size += sprintf(&buf[size], "<h2>Neighbors</h2>\n");
-  size += sprintf(&buf[size], "<table width=\"100%%\" BORDER=0 CELLSPACING=0 CELLPADDING=0 ALIGN=center><tr><th>IP address</th><th>SYM</th><th>MPR</th><th>MPRS</th><th>Willingness</th><th>2 Hop Neighbors</th></tr>\n");
+  size += snprintf(&buf[size], bufsize-size, "<h2>Neighbors</h2>\n");
+  size += snprintf(&buf[size], bufsize-size, "<table width=\"100%%\" BORDER=0 CELLSPACING=0 CELLPADDING=0 ALIGN=center><tr><th>IP address</th><th>SYM</th><th>MPR</th><th>MPRS</th><th>Willingness</th><th>2 Hop Neighbors</th></tr>\n");
   /* Neighbors */
   for(index=0;index<HASHSIZE;index++)
     {
@@ -1030,22 +1075,20 @@
 	  neigh != &neighbortable[index];
 	  neigh = neigh->next)
 	{
-	  size += sprintf(&buf[size], 
-			  "<tr><td><a href=\"http://%s:%d/all\">%s</a></td>"
+          size += snprintf(&buf[size], bufsize-size, "<tr>");
+          size += build_ipaddr_with_link(&buf[size], bufsize, &neigh->neighbor_main_addr, NULL);
+	  size += snprintf(&buf[size], bufsize-size, 
 			  "<td>%s</td>"
 			  "<td>%s</td>"
 			  "<td>%s</td>"
 			  "<td>%d</td>", 
-			  olsr_ip_to_string(&neigh->neighbor_main_addr),
-                          http_port,
-			  olsr_ip_to_string(&neigh->neighbor_main_addr),
 			  (neigh->status == SYM) ? "YES" : "NO",
 			  neigh->is_mpr ? "YES" : "NO",
 			  olsr_lookup_mprs_set(&neigh->neighbor_main_addr) ? "YES" : "NO",
 			  neigh->willingness);
 
-	  size += sprintf(&buf[size], "<td><select>\n");
-	  size += sprintf(&buf[size], "<option>IP ADDRESS</option>\n");
+	  size += snprintf(&buf[size], bufsize-size, "<td><select>\n");
+	  size += snprintf(&buf[size], bufsize-size, "<option>IP ADDRESS</option>\n");
 
 	  thop_cnt = 0;
 
@@ -1053,15 +1096,15 @@
 	      list_2 != &neigh->neighbor_2_list;
 	      list_2 = list_2->next)
 	    {
-	      size += sprintf(&buf[size], "<option>%s</option>\n", olsr_ip_to_string(&list_2->neighbor_2->neighbor_2_addr));
+              size += snprintf(&buf[size], bufsize-size, "<option>%s</option>", olsr_ip_to_string(&list_2->neighbor_2->neighbor_2_addr));
 	      thop_cnt ++;
 	    }
-	  size += sprintf(&buf[size], "</select> (%d)</td></tr>\n", thop_cnt);
+	  size += snprintf(&buf[size], bufsize-size, "</select> (%d)</td></tr>\n", thop_cnt);
 
 	}
     }
 
-  size += sprintf(&buf[size], "</table>\n");
+  size += snprintf(&buf[size], bufsize-size, "</table>\n");
 
   return size;
 }
@@ -1077,10 +1120,10 @@
   struct topo_dst *dst_entry;
 
 
-  size += sprintf(&buf[size], "<h2>Topology entries</h2>\n<table width=\"100%%\" BORDER=0 CELLSPACING=0 CELLPADDING=0 ALIGN=center><tr><th>Destination IP</th><th>Last hop IP</th>");
+  size += snprintf(&buf[size], bufsize-size, "<h2>Topology entries</h2>\n<table width=\"100%%\" BORDER=0 CELLSPACING=0 CELLPADDING=0 ALIGN=center><tr><th>Destination IP</th><th>Last Hop IP</th>");
   if (olsr_cnf->lq_level > 0)
-    size += sprintf(&buf[size], "<th>LQ</th><th>ILQ</th><th>ETX</th>");
-  size += sprintf(&buf[size], "</tr>\n");
+    size += snprintf(&buf[size], bufsize-size, "<th>LQ</th><th>ILQ</th><th>ETX</th>");
+  size += snprintf(&buf[size], bufsize-size, "</tr>\n");
 
 
   /* Topology */  
@@ -1094,26 +1137,21 @@
 	  dst_entry = entry->destinations.next;
 	  while(dst_entry != &entry->destinations)
 	    {
-	      size += sprintf(&buf[size],
-                             "<tr><td><a href=\"http://%s:%d/all\">%s</a></td>"
-                             "<td><a href=\"http://%s:%d/all\">%s</a></td>",
-                             olsr_ip_to_string(&dst_entry->T_dest_addr),
-                             http_port,
-                             olsr_ip_to_string(&dst_entry->T_dest_addr),
-                             olsr_ip_to_string(&entry->T_last_addr), 
-                             http_port,
-                             olsr_ip_to_string(&entry->T_last_addr));
+              size += snprintf(&buf[size], bufsize-size, "<tr>");
+              size += build_ipaddr_with_link(&buf[size], bufsize, &dst_entry->T_dest_addr, NULL);
+              size += build_ipaddr_with_link(&buf[size], bufsize, &entry->T_last_addr, NULL);
               if (olsr_cnf->lq_level > 0)
                 {
-	          size += sprintf(&buf[size],
-                                 "<td>%0.2f</td>"
-                                 "<td>%0.2f</td>"
-                                 "<td>%0.2f</td>\n",
+                  const double d = dst_entry->link_quality * dst_entry->inverse_link_quality;
+	          size += snprintf(&buf[size], bufsize-size,
+                                 "<td align=\"right\">%0.2f</td>"
+                                 "<td align=\"right\">%0.2f</td>"
+                                 "<td align=\"right\">%0.2f</td>\n",
                                  dst_entry->link_quality,
                                  dst_entry->inverse_link_quality,
-                                 (dst_entry->link_quality * dst_entry->inverse_link_quality) ? 1.0 / (dst_entry->link_quality * dst_entry->inverse_link_quality) : 0.0);
+                                 d ? 1.0 / d : 0.0);
                 }
-	      size += sprintf(&buf[size], "</tr>\n");
+	      size += snprintf(&buf[size], bufsize-size, "</tr>\n");
 
 	      dst_entry = dst_entry->next;
 	    }
@@ -1121,7 +1159,7 @@
 	}
     }
 
-  size += sprintf(&buf[size], "</table>\n");
+  size += snprintf(&buf[size], bufsize-size, "</table>\n");
 
   return size;
 }
@@ -1138,7 +1176,7 @@
 
   size = 0;
 
-  size += sprintf(&buf[size], "<h2>HNA entries</h2>\n<table width=\"100%%\" BORDER=0 CELLSPACING=0 CELLPADDING=0 ALIGN=center><tr><th>Network</th><th>Netmask</th><th>Gateway</th></tr>\n");
+  size += snprintf(&buf[size], bufsize-size, "<h2>HNA entries</h2>\n<table width=\"100%%\" BORDER=0 CELLSPACING=0 CELLPADDING=0 ALIGN=center><tr><th>Network</th><th>Netmask</th><th>Gateway</th></tr>\n");
 
   /* HNA entries */
   for(index=0;index<HASHSIZE;index++)
@@ -1152,14 +1190,11 @@
 	      
 	  while(tmp_net != &tmp_hna->networks)
 	    {
-	      size += sprintf(&buf[size], "<tr><td>%s</td>", 
-			      olsr_ip_to_string(&tmp_net->A_network_addr));
-	      size += sprintf(&buf[size], "<td>%s</td>",
+              size += snprintf(&buf[size], bufsize-size, "<tr>");
+              size += build_ipaddr_no_link(&buf[size], bufsize, &tmp_net->A_network_addr, NULL);
+	      size += snprintf(&buf[size], bufsize-size, "<td>%s</td>",
 			      olsr_netmask_to_string(&tmp_net->A_netmask));
-	      size += sprintf(&buf[size], "<td><a href=\"http://%s:%d/all\">%s</a></td></tr>\n",
-                              olsr_ip_to_string(&tmp_hna->A_gateway_addr),
-                              http_port,
-                              olsr_ip_to_string(&tmp_hna->A_gateway_addr));
+              size += build_ipaddr_with_link(&buf[size], bufsize, &tmp_hna->A_gateway_addr, NULL);
 	      tmp_net = tmp_net->next;
 	    }
 	      
@@ -1167,7 +1202,7 @@
 	}
     }
 
-  size += sprintf(&buf[size], "</table>\n");
+  size += snprintf(&buf[size], bufsize-size, "</table>\n");
 
   return size;
 }
@@ -1176,42 +1211,37 @@
 int
 build_mid_body(char *buf, olsr_u32_t bufsize)
 {
-  int size = 0, mid_cnt;
+  int size = 0;
   olsr_u8_t index;
-  struct mid_entry *entry;
-  struct mid_address *alias;
 
-  size += sprintf(&buf[size], "<h2>MID entries</h2>\n<table width=\"100%%\" BORDER=0 CELLSPACING=0 CELLPADDING=0 ALIGN=center><tr><th>Main Address</th><th>Aliases</th></tr>\n");
+  size += snprintf(&buf[size], bufsize-size, "<h2>MID entries</h2>\n<table width=\"100%%\" BORDER=0 CELLSPACING=0 CELLPADDING=0 ALIGN=center><tr><th>Main Address</th><th>Aliases</th></tr>\n");
   
   /* MID */  
-  for(index=0;index<HASHSIZE;index++)
+  for(index = 0;index < HASHSIZE; index++)
     {
-      entry = mid_set[index].next;
+      struct mid_entry *entry = mid_set[index].next;
       while(entry != &mid_set[index])
 	{
-	  size += sprintf(&buf[size], "<tr><td><a href=\"http://%s:%d/all\">%s</a></td>\n",
-	                  olsr_ip_to_string(&entry->main_addr),
-                          http_port,
-	                  olsr_ip_to_string(&entry->main_addr));
-	  size += sprintf(&buf[size], "<td><select>\n<option>IP ADDRESS</option>\n");
+          int mid_cnt;
+          struct mid_address *alias;
+          size += snprintf(&buf[size], bufsize-size, "<tr>");
+          size += build_ipaddr_with_link(&buf[size], bufsize, &entry->main_addr, NULL);
+	  size += snprintf(&buf[size], bufsize-size, "<td><select>\n<option>IP ADDRESS</option>\n");
 
 	  alias = entry->aliases;
 	  mid_cnt = 0;
 	  while(alias)
 	    {
-	      size += sprintf(&buf[size], "<option>%s</option>\n", olsr_ip_to_string(&alias->alias));
-	      mid_cnt ++;
+	      size += snprintf(&buf[size], bufsize-size, "<option>%s</option>\n", olsr_ip_to_string(&alias->alias));
+	      mid_cnt++;
 	      alias = alias->next_alias;
 	    }
-	  size += sprintf(&buf[size], "</select> (%d)</td></tr>\n", mid_cnt);
+	  size += snprintf(&buf[size], bufsize-size, "</select> (%d)</td></tr>\n", mid_cnt);
 	  entry = entry->next;
 	}
     }
 
-  size += sprintf(&buf[size], "</table>\n");
-
-
-
+  size += snprintf(&buf[size], bufsize-size, "</table>\n");
   return size;
 }
 
@@ -1221,10 +1251,10 @@
 {
   int size = 0;
 
-  size += build_neigh_body(buf, bufsize);
-  size += build_topo_body(&buf[size], bufsize - size);
-  size += build_hna_body(&buf[size], bufsize - size);
-  size += build_mid_body(&buf[size], bufsize - size);
+  size += build_neigh_body(&buf[size], bufsize-size);
+  size += build_topo_body(&buf[size], bufsize-size);
+  size += build_hna_body(&buf[size], bufsize-size);
+  size += build_mid_body(&buf[size], bufsize-size);
 
   return size;
 }
@@ -1234,12 +1264,12 @@
 {
   int size = 0;
 
-  size += build_config_body(&buf[size], bufsize);
-  size += build_routes_body(&buf[size], bufsize - size);
-  size += build_neigh_body(&buf[size], bufsize);
-  size += build_topo_body(&buf[size], bufsize - size);
-  size += build_hna_body(&buf[size], bufsize - size);
-  size += build_mid_body(&buf[size], bufsize - size);
+  size += build_config_body(&buf[size], bufsize-size);
+  size += build_routes_body(&buf[size], bufsize-size);
+  size += build_neigh_body(&buf[size], bufsize-size);
+  size += build_topo_body(&buf[size], bufsize-size);
+  size += build_hna_body(&buf[size], bufsize-size);
+  size += build_mid_body(&buf[size], bufsize-size);
 
   return size;
 }
@@ -1250,11 +1280,10 @@
 {
   int size = 0, i = 0;
 
-  while(about_frame[i])
-    {
-      size += sprintf(&buf[size], about_frame[i]);
+  while(about_frame[i]) {
+      size += snprintf(&buf[size], bufsize-size, about_frame[i]);
       i++;
-    }
+  }
   return size;
 }
 
@@ -1263,36 +1292,33 @@
 {
   int size = 0, i = 0;
 
-  while(cfgfile_body[i] && strcmp(cfgfile_body[i], "<!-- CFGFILE -->"))
-    {
-      size += sprintf(&buf[size], cfgfile_body[i]);
+  while(cfgfile_body[i] && strcmp(cfgfile_body[i], "<!-- CFGFILE -->")) {
+      size += snprintf(&buf[size], bufsize-size, cfgfile_body[i]);
       i++;
-    }
+  }
 
 #ifdef NETDIRECT
-    {
+  {
         /* Hack to make netdirect stuff work with
            olsrd_write_cnf_buf
         */
         char tmpBuf[10000];
         size = olsrd_write_cnf_buf(olsr_cnf, tmpBuf, 10000);
-        sprintf(&buf[size], tmpBuf);
-    }
+        snprintf(&buf[size], bufsize-size, tmpBuf);
+  }
 #else
-  size += olsrd_write_cnf_buf(olsr_cnf, &buf[size], bufsize - size);
+  size += olsrd_write_cnf_buf(olsr_cnf, &buf[size], bufsize-size);
 #endif
   
-  if(size < 0)
-    {
+  if(size < 0) {
       size = sprintf(&buf[0], "ERROR GENERATING CONFIGFILE!\n");
-    }
+  }
 
   i++;
-  while(cfgfile_body[i])
-    {
-      size += sprintf(&buf[size], cfgfile_body[i]);
+  while(cfgfile_body[i]) {
+      size += snprintf(&buf[size], bufsize-size, cfgfile_body[i]);
       i++;
-    }
+  }
   printf("RETURNING %d\n", size);
   return size;
 }
@@ -1334,35 +1360,21 @@
 olsr_netmask_to_string(union hna_netmask *mask)
 {
   char *ret;
-  struct in_addr in;
-  static char netmask[5];
-
-  if(olsr_cnf->ip_version == AF_INET)
-    {
+  if(olsr_cnf->ip_version == AF_INET) {
+      struct in_addr in;
       in.s_addr = mask->v4;
       ret = inet_ntoa(in);
-      return ret;
-
-    }
-  else
-    {
+  } else {
+      static char netmask[5];
       /* IPv6 */
       snprintf(netmask, sizeof(netmask), "%d", mask->v6);
-      return netmask;
-    }
-
+      ret = netmask;
+  }
   return ret;
 }
 
 
-
-
-static char *
-get_copyright_string()
-{
-  return copyright_string;
-}
-
+#if 0
 /*
  * In a bigger mesh, there are probs with the fixed
  * bufsize. Because the Content-Length header is
@@ -1388,3 +1400,23 @@
 	}
 	return rv;
 }
+#endif
+
+static ssize_t writen(int fd, const void *buf, size_t count)
+{
+    size_t bytes_left = count;
+    const char *p = buf;
+    while (bytes_left > 0) {
+        const ssize_t written = write(fd, p, bytes_left);
+        if (written == -1)  { /* error */
+            if (errno == EINTR ) {
+                continue;
+            }
+            return -1;
+        }
+        /* We wrote something */
+        bytes_left -= written;
+        p += written;
+    }
+    return count;
+}
diff --exclude=CVS --exclude=.cvsignore -Nur olsrd-0.5.0/lib/httpinfo/src/olsrd_httpinfo.h olsrd-current/lib/httpinfo/src/olsrd_httpinfo.h
--- olsrd-0.5.0/lib/httpinfo/src/olsrd_httpinfo.h	2005-05-29 14:47:41.000000000 +0200
+++ olsrd-current/lib/httpinfo/src/olsrd_httpinfo.h	2007-04-20 16:06:18.000000000 +0200
@@ -36,7 +36,7 @@
  * to the project. For more information see the website or contact
  * the copyright holders.
  *
- * $Id: olsrd_httpinfo.h,v 1.28 2005/05/29 12:47:41 br1 Exp $
+ * $Id: olsrd_httpinfo.h,v 1.29 2007/04/20 14:06:18 bernd67 Exp $
  */
 
 /*
@@ -82,9 +82,6 @@
 
 
 char *
-olsr_ip_to_string(union olsr_ip_addr *);
-
-char *
 olsr_netmask_to_string(union hna_netmask *);
 
 /* Destructor function */
diff --exclude=CVS --exclude=.cvsignore -Nur olsrd-0.5.0/lib/httpinfo/src/olsrd_plugin.c olsrd-current/lib/httpinfo/src/olsrd_plugin.c
--- olsrd-0.5.0/lib/httpinfo/src/olsrd_plugin.c	2007-02-04 23:37:36.000000000 +0100
+++ olsrd-current/lib/httpinfo/src/olsrd_plugin.c	2007-05-09 02:22:47.000000000 +0200
@@ -36,7 +36,7 @@
  * to the project. For more information see the website or contact
  * the copyright holders.
  *
- * $Id: olsrd_plugin.c,v 1.13 2007/02/04 22:37:36 bernd67 Exp $
+ * $Id: olsrd_plugin.c,v 1.16 2007/05/09 00:22:47 bernd67 Exp $
  */
 
 /*
@@ -49,9 +49,16 @@
 #include <stdio.h>
 #include <string.h>
 #include <stdlib.h>
+#include <netinet/in.h>
+#ifndef WIN32
+#include <arpa/nameser.h>
+#endif
+
 #include "olsrd_httpinfo.h"
 
+
 int http_port = 0;
+int resolve_ip_addresses = 0;
 
 static void __attribute__ ((constructor)) 
 my_init(void);
@@ -59,14 +66,13 @@
 static void __attribute__ ((destructor)) 
 my_fini(void);
 
-
 /*
  * Defines the version of the plugin interface that is used
  * THIS IS NOT THE VERSION OF YOUR PLUGIN!
  * Do not alter unless you know what you are doing!
  */
 int 
-olsrd_plugin_interface_version()
+olsrd_plugin_interface_version(void)
 {
   return PLUGIN_INTERFACE_VERSION;
 }
@@ -77,11 +83,11 @@
  *Constructor
  */
 static void
-my_init()
+my_init(void)
 {
   /* Print plugin info to stdout */
   printf("%s\n", MOD_DESC);
-  
+
   return;
 }
 
@@ -89,7 +95,7 @@
  *Destructor
  */
 static void
-my_fini()
+my_fini(void)
 {
 
   /* Calls the destruction function
@@ -166,6 +172,15 @@
       return 1;
       
     }
-
+  if(!strcasecmp(key, "resolve"))
+    {
+        if (!strcasecmp (value, "yes")) {
+            resolve_ip_addresses = 1;
+        } else if (!strcasecmp (value, "no")) {
+            resolve_ip_addresses = 0;
+        } else {
+            return 0;
+        }
+    }
   return 1;
 }
diff --exclude=CVS --exclude=.cvsignore -Nur olsrd-0.5.0/lib/httpinfo/src/olsrd_plugin.h olsrd-current/lib/httpinfo/src/olsrd_plugin.h
--- olsrd-0.5.0/lib/httpinfo/src/olsrd_plugin.h	2007-02-04 23:37:36.000000000 +0100
+++ olsrd-current/lib/httpinfo/src/olsrd_plugin.h	2007-04-03 00:22:26.000000000 +0200
@@ -36,7 +36,7 @@
  * to the project. For more information see the website or contact
  * the copyright holders.
  *
- * $Id: olsrd_plugin.h,v 1.21 2007/02/04 22:37:36 bernd67 Exp $
+ * $Id: olsrd_plugin.h,v 1.22 2007/04/02 22:22:26 bernd67 Exp $
  */
 
 /*
@@ -72,6 +72,7 @@
 #define PLUGIN_INTERFACE_VERSION 4
 
 extern int http_port;
+extern int resolve_ip_addresses;
 
 /* Allowed hosts stuff */
 
diff --exclude=CVS --exclude=.cvsignore -Nur olsrd-0.5.0/lib/Makefile olsrd-current/lib/Makefile
--- olsrd-0.5.0/lib/Makefile	2007-02-14 22:47:06.000000000 +0100
+++ olsrd-current/lib/Makefile	2007-04-03 12:08:53.000000000 +0200
@@ -1,8 +1,8 @@
-# This is quite ougly but at least it works
+# This is quite ugly but at least it works
 ifeq ($(OS),linux)
 SUBDIRS := $(shell find -maxdepth 2 -name Makefile -not -path ./Makefile -printf "%h\n")
 else
-SUBDIRS := dot_draw dyn_gw dyn_gw_plain httpinfo mini nameservice pgraph secure txtinfo
+SUBDIRS := bmf dot_draw dyn_gw dyn_gw_plain httpinfo mini nameservice pgraph secure txtinfo
 endif
 
 .PHONY: $(SUBDIRS)
@@ -12,4 +12,4 @@
 install: $(SUBDIRS)
 
 $(SUBDIRS):
-	$(MAKE) -C $@ $(MAKECMDGOALS)
+	$(MAKE) OS=$(OS) -C $@ $(MAKECMDGOALS)
diff --exclude=CVS --exclude=.cvsignore -Nur olsrd-0.5.0/lib/mini/README_MINI olsrd-current/lib/mini/README_MINI
--- olsrd-0.5.0/lib/mini/README_MINI	1970-01-01 01:00:00.000000000 +0100
+++ olsrd-current/lib/mini/README_MINI	2007-04-03 11:48:45.000000000 +0200
@@ -0,0 +1,36 @@
+---------------------------------------------------------------------
+MINI PLUGIN FOR OLSRD
+by Bruno Randolf <bruno.randolf@4g-systems.biz>
+---------------------------------------------------------------------
+
+This is a minimal example plugin to demonstrate the functions a plugin
+must implement. It documents the minimal requirements for the new
+plugin interface and is a good start for creating new plugins and 
+testing the plugin loader.
+
+This plugin does nothing, except printing messages when it is loaded
+and unloaded.
+
+
+---------------------------------------------------------------------
+PLUGIN PARAMETERS (PlParam)
+---------------------------------------------------------------------
+
+PlParam "test" "anything"
+	just for a test: print the parameter.
+
+
+---------------------------------------------------------------------
+SAMPLE CONFIG
+---------------------------------------------------------------------
+
+add in /etc/olsrd.conf:
+
+LoadPlugin "olsrd_mini.so.0.1"
+{
+	PlParam "test" "hello"
+}
+
+
+---------------------------------------------------------------------
+EOF / 26.05.2005
diff --exclude=CVS --exclude=.cvsignore -Nur olsrd-0.5.0/lib/mini/src/olsrd_plugin.c olsrd-current/lib/mini/src/olsrd_plugin.c
--- olsrd-0.5.0/lib/mini/src/olsrd_plugin.c	2005-05-29 14:47:41.000000000 +0200
+++ olsrd-current/lib/mini/src/olsrd_plugin.c	2007-04-20 15:46:02.000000000 +0200
@@ -29,7 +29,7 @@
  *
  */
 
-/* $Id: olsrd_plugin.c,v 1.2 2005/05/29 12:47:41 br1 Exp $ */
+/* $Id: olsrd_plugin.c,v 1.3 2007/04/20 13:46:02 bernd67 Exp $ */
 
  /*
  * Example plugin for olsrd.org OLSR daemon
@@ -43,6 +43,8 @@
 #include "olsrd_plugin.h"
 #include "olsr.h"
 
+#define PLUGIN_INTERFACE_VERSION 1
+
 
 /****************************************************************************
  *                Functions that the plugin MUST provide                    *
@@ -53,9 +55,9 @@
  * Used by main olsrd to check plugin interface version
  */
 int 
-olsrd_plugin_interface_version()
+olsrd_plugin_interface_version(void)
 {
-	return OLSRD_PLUGIN_INTERFACE_VERSION;
+	return PLUGIN_INTERFACE_VERSION;
 }
 
 
@@ -79,7 +81,7 @@
  * Called after all parameters are passed
  */
 int
-olsrd_plugin_init()
+olsrd_plugin_init(void)
 {
 	printf("*** MINI: plugin_init\n");
 	
@@ -107,7 +109,7 @@
  * Optional Private Constructor
  */
 static void
-my_init()
+my_init(void)
 {
 	printf("*** MINI: constructor\n");
 }
@@ -117,7 +119,7 @@
  * Optional Private Destructor
  */
 static void
-my_fini()
+my_fini(void)
 {
 	printf("*** MINI: destructor\n");
 }
diff --exclude=CVS --exclude=.cvsignore -Nur olsrd-0.5.0/lib/mini/src/olsrd_plugin.h olsrd-current/lib/mini/src/olsrd_plugin.h
--- olsrd-0.5.0/lib/mini/src/olsrd_plugin.h	1970-01-01 01:00:00.000000000 +0100
+++ olsrd-current/lib/mini/src/olsrd_plugin.h	2007-04-20 16:18:56.000000000 +0200
@@ -0,0 +1,55 @@
+/*
+ * Copyright (c) 2005, Bruno Randolf <bruno.randolf@4g-systems.biz>
+ * Copyright (c) 2004, Andreas Tønnesen(andreto-at-olsr.org)
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without 
+ * modification, are permitted provided that the following conditions 
+ * are met:
+ *
+ * * Redistributions of source code must retain the above copyright notice, 
+ *   this list of conditions and the following disclaimer.
+ * * Redistributions in binary form must reproduce the above copyright notice, 
+ *   this list of conditions and the following disclaimer in the documentation 
+ *   and/or other materials provided with the distribution.
+ * * Neither the name of the UniK olsr daemon nor the names of its contributors 
+ *   may be used to endorse or promote products derived from this software 
+ *   without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND 
+ * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED 
+ * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. 
+ * IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, 
+ * INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, 
+ * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, 
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY 
+ * OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE 
+ * OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED 
+ * OF THE POSSIBILITY OF SUCH DAMAGE.
+ *
+ */
+
+/*
+ * Dynamic linked library for the olsr.org olsr daemon
+ */
+
+#ifndef _OLSRD_PLUGIN_MINI
+#define _OLSRD_PLUGIN_MINI
+
+
+/****************************************************************************
+ *                Functions that the plugin MUST provide                    *
+ ****************************************************************************/
+
+
+/* Initialization function */
+int
+olsrd_plugin_init(void);
+
+int
+olsrd_plugin_register_param(char *, char *);
+
+int 
+olsrd_plugin_interface_version(void);
+
+#endif
diff --exclude=CVS --exclude=.cvsignore -Nur olsrd-0.5.0/lib/nameservice/Makefile olsrd-current/lib/nameservice/Makefile
--- olsrd-0.5.0/lib/nameservice/Makefile	2005-05-25 15:50:22.000000000 +0200
+++ olsrd-current/lib/nameservice/Makefile	2007-05-09 19:30:42.000000000 +0200
@@ -35,7 +35,7 @@
 # to the project. For more information see the website or contact
 # the copyright holders.
 #
-# $Id: Makefile,v 1.10 2005/05/25 13:50:22 br1 Exp $
+# $Id: Makefile,v 1.11 2007/05/09 17:30:42 bernd67 Exp $
 
 OLSRD_PLUGIN =	true
 PLUGIN_NAME =	olsrd_nameservice
@@ -44,6 +44,10 @@
 TOPDIR = ../..
 include $(TOPDIR)/Makefile.inc
 
+ifeq ($(OS),win32)
+default_target install clean:
+	@echo "**** We use the regex library here. Does Win32 has something like this?"
+else
 default_target: $(PLUGIN_FULLNAME)
 
 $(PLUGIN_FULLNAME): $(OBJS)
@@ -55,3 +59,4 @@
 
 clean:
 		rm -f $(OBJS) $(SRCS:%.c=%.d) $(PLUGIN_FULLNAME)
+endif
\ Kein Zeilenumbruch am Dateiende.
diff --exclude=CVS --exclude=.cvsignore -Nur olsrd-0.5.0/lib/nameservice/README_NAMESERVICE olsrd-current/lib/nameservice/README_NAMESERVICE
--- olsrd-0.5.0/lib/nameservice/README_NAMESERVICE	1970-01-01 01:00:00.000000000 +0100
+++ olsrd-current/lib/nameservice/README_NAMESERVICE	2007-04-03 11:48:45.000000000 +0200
@@ -0,0 +1,125 @@
+---------------------------------------------------------------------
+NAMESERVICE PLUGIN FOR OLSRD
+by Bruno Randolf <bruno.randolf@4g-systems.biz>
+---------------------------------------------------------------------
+
+a simple DNS replacement for OLSR networks
+
+this plugin distributes host name (DNS) information over OLSR. every 
+node which runs the olsr daemon can announce it's own name, names for
+other IP adresses it is associated with (HNAs) and if it is running
+a "real" nameserver which can resolve other (internet) names (upstream 
+dns server).
+
+the nodes in the network collect this information and write the host 
+names to a file (possibly /etc/hosts), and the 3 nearest upstream 
+nameservers to another file (possibly /etc/resolv.conf).
+
+these files can be used to resolve hostnames on the local system and/or
+be read by a DNS server like "dnsmasq", to make the names available 
+via the ordinary DNS protocol to other clients as well.
+
+the default location of the hosts file is
+"/var/run/hosts_olsr" on unixes
+"C:\WINDOWS\hosts_olsr" on windows
+
+
+---------------------------------------------------------------------
+PLUGIN PARAMETERS (PlParam)
+---------------------------------------------------------------------
+
+PlParam "name" "my-name.mesh"
+	the name of this OLSR node (main address).
+	can be specified multiple times for different names.
+
+PlParam "IP.ADDR" "another-name.mesh"
+	a name for a specified IP address.
+	the IP address has to be either from one of the olsr 
+	interfaces or within a HNA network we announce.
+	can be specified multiple times.
+
+PlParam "hosts-file" "/path/to/hosts_file"
+	which file to write to (usually /etc/hosts).
+	(default: /var/run/hosts_olsr)
+
+PlParam "suffix" ".olsr"
+	local suffix which is appended to all received names.
+	(default: "")
+
+PlParam "add-hosts" "/path/to/file"
+	copy contents of this additional hosts file to output file.
+	this is practical if you alreay use your /etc/hosts file.
+
+PlParam "dns-server" "IP.ADDR"
+	anounce that this IP has a full (upstream) DNS server. if 
+	IP.ADDR is not specified (""), the main address is used.
+	nodes which don't know a nameserver will automatically use
+	this nameserver.
+
+PlParam "resolv-file" "/path/to/resolv.conf"
+	path to resolv.conf file (usually /etc/resolv.conf)
+	if set, the 3 nearest (best ETX) upstream nameservers annonced 
+	by other nodes in the network are written to this file
+
+PlParam "interval" "SEC"
+	interval for sending NAME messages in seconds.
+	(default: 120 - 2 minutes)
+
+PlParam "timeout" "SEC"
+	validity time for received NAME messages in seconds.
+	(default: 3600 - 1 hour)
+
+
+---------------------------------------------------------------------
+SAMPLE CONFIG
+---------------------------------------------------------------------
+
+add in /etc/olsrd.conf:
+
+LoadPlugin "olsrd_nameservice.so.0.2"
+{
+	PlParam "name" "thisismyname"
+	PlParam "hosts-file" "/etc/hosts"
+	PlParam "resolv-file" "/etc/resolv.conf"
+}
+
+
+---------------------------------------------------------------------
+USING THE NAME INFORMATION
+---------------------------------------------------------------------
+
+to use the name information distributed by the plugin actually for
+name resolution you can do one of the following.
+
+UNIX VARIANTS:
+
+* overwrite /etc/hosts
+	be sure you have nothing in /etc/hosts which you still need and
+	configure the plugin with PlParam "host-file" "/etc/hosts"
+
+* link /etc/hosts
+	ln -s /var/run/hosts_olsr /etc/hosts
+
+* use dnsmasq
+	if you want to make the names available via ordinary DNS
+	you can use dnsmasq to read the hosts file and serve it to
+	users. add "addn-hosts=/var/run/hosts_olsr" to dnsmasq.conf 
+	and restart dnsmasq
+
+WINDOWS:
+
+* overwrite C:\WINDOWS\system32\drivers\etc\hosts
+	be sure you have nothing in the file which you still need 
+	and configure the plugin with
+	PlParam "filename" "C:\WINDOWS\system32\drivers\etc\hosts"
+
+
+---------------------------------------------------------------------
+TODO
+---------------------------------------------------------------------
+  
+  * implement a small DNS server into the plugin?
+  * or make dynamic DNS updates for bind?
+
+---------------------------------------------------------------------
+EOF / 20.04.2005
